image: ubuntu:latest

stages:
  - build
  - test
  - deploy

#### 1 #####
# variables:
#   HOST: "http://google.com"
#   HOST2: "http://uol.com.br"

# Criando-Build-Utilizando-Variavel:
#   stage: build
#   script:
#     - echo ${HOST}
#     - echo ${HOST2}





##### 2 #####
# Criando-Build-Utilizando-Variavel-e-enviorements:
#   stage: build
#   script:
#     - echo ${HOST}
#     - echo ${SERVIDOR}
#   environment: Producao

# Criando-Build-Utilizando-Variavel-de-DEV:
#   stage: build
#   script:
#     - echo ${HOST}
#   environment: Desenvolvimento

##### 2 ########
# Link Doc
# https://docs.gitlab.com/ee/ci/yaml/includes.html

#include: '/gitfiles/git_qa.yml'

##### 3  Rodando sem escolha de Job ######
    
# include:
#   - project: 'devopsbr-aulas/gitlab/aula-1'
#     ref: develop
#     file: 'jobs/analise_vulnerabilidade.yml'


    
#### 4 Rodando com Extends com escolha de job

# include:
#   - project: 'devopsbr-aulas/gitlab/aula-1'
#     ref: develop
#     file: 'jobs/analise_vulnerabilidade_multiplo.yml'

# Teste-De-Seguranca-Multiplo-Escolhendo-Job:
#   extends: ['.Analisando-Vulnerabilidade-1','.Analisando-Vulnerabilidade-2']


 #### 5 Docker Build and push ####
Build-Image-Docker:
  stage: build 
  image: docker:20.10.16
  services:
    - docker:20.10.16-dind
  script:
      - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
      - docker build -t registry.gitlab.com/devopsbr-aulas/gitlab/aula-2 .
      - docker push registry.gitlab.com/devopsbr-aulas/gitlab/aula-2


Test-Image-Docker:
  stage: test
  image: docker:20.10.16
  services:
    #- docker:20.10.16-dind
    - name: docker:20.10.16-dind
      alias: localhost
    
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker run -d -p 8888:8888 registry.gitlab.com/devopsbr-aulas/gitlab/aula-2:latest #wget http://localhost:3000/
    - echo $HOSTNAME
    - sleep 15
    - cat /etc/hosts
    - wget -q -S -O - http://docker:8888 2>&1
   




#################################
# Primeiro-Job:
#   stage: build
#   script:
#     - echo "Testando"
  

# Segundoo-Job-qualquer:
#   stage: build
#   script:
#     - echo "Testando 2"
#   needs: ["Primeiro-Job"]



# Compilando-Windows-Develop:
#   stage: build
#   script:
#     - echo "Estou compilando para o Windows"
#     - echo "Ola Mundo" ola.txt
#     - scp ubuntu@192.168.0.28:/var/html/www
#     #- cat asdasdasdasd.txt
#   only:
#     - develop


# Compilando-Linux-Develop:
#   stage: build
#   script:
#     - echo "Estou compilando para o Linux"
#   only:
#     - develop

# Compilando-Mac-Develop:
#   stage: build
#   script:
#     - echo "Estou compilando para o MAC"
#   only:
#     - develop


# Compilando-Windows-Prod:
#   stage: build
#   script:
#     - echo "Estou compilando para o Windows"
#   only:
#     - main


# Compilando-Linux-Prod:
#   stage: build
#   script:
#     - echo "Estou compilando para o Linux"
#   only:
#     - main

# Compilando-Mac-Prod:
#   stage: build
#   script:
#     - echo "Estou compilando para o MAC"
#   only:
#     - main

# Testando-Windows-Develop:
#   stage: test
#   script:
#     - echo "Iniciando o meu golang Server"
#     - echo "Rodando comando de Testes Windows"
#   needs: ["Compilando-Windows-Develop"]

# Testando-Mac:
#   stage: test
#   script:
#     - echo "Iniciando o meu golang Server"
#     - echo "Rodando comando de Testes Mac"
#   needs: ["Compilando-Mac-Develop"]

# Testando-Linux:
#   stage: test
#   script:
#     - echo "Iniciando o meu golang Server"
#     - echo "Rodando comando de Testes Linux"
#   needs: ["Compilando-Linux-Develop"]

# Testando-Linux-Sequencia-1:
#   stage: test
#   script:
#     - echo "Iniciando o meu golang Server"
#     - echo "Testando teste 1"
#   needs: ["Compilando-Linux-Develop"]

# Testando-Linux-Sequencia-2:
#   stage: test
#   script:
#     - echo "Iniciando o meu golang Server"
#     - echo "Testando teste 2"
#   needs: ["Testando-Linux-Sequencia-1"]

# Testando-Linux-Sequencia-3:
#   stage: test
#   script:
#     - echo "Iniciando o meu golang Server"
#     - echo "Testando teste 3"
#   needs: ["Testando-Linux-Sequencia-2"]

# Testando-Mac-Paralela-1:
#   stage: test
#   script:
#     - echo "Iniciando o meu golang Server"
#     - echo "Testando teste 1"
#   needs: ["Compilando-Mac-Develop"]

# Testando-Mac-Paralela-2:
#   stage: test
#   script:
#     - echo "Iniciando o meu golang Server"
#     - echo "Testando teste 2"
#   needs: ["Compilando-Mac-Develop"]

# Testando-Mac-Paralela-3:
#   stage: test
#   script:
#     - echo "Iniciando o meu golang Server"
#     - echo "Testando teste 3"
#   needs: ["Compilando-Mac-Develop"]

# Testando-Mac-Paralela-4:
#   stage: test
#   script:
#     - echo "Iniciando o meu golang Server"
#     - echo "Testando teste 4"
#   needs: ["Compilando-Mac-Develop"]

# Testando-Mac-Paralela-5:
#   stage: test
#   script:
#     - echo "Iniciando o meu golang Server"
#     - echo "Testando teste 5"
#   needs: ["Compilando-Mac-Develop"]


# Build-Windows-Develop-Artefato:
#   stage: build
#   script:
#     - pwd
#     - echo "Ola mundo" >> ./meu-arquivo.txt
#   artifacts:
#     paths:
#       - ./meu-arquivo.txt
#   only:
#     - develop

# Testando-Windows-Develop-Artefato:
#   stage: test
#   script:
#     - cat ./meu-arquivo.txt
#   artifacts:
#     paths:
#       - ./meu-arquivo.txt
#   only:
#     - develop


# deploy-to-prod-only-add-tag:
#   stage: deploy
#   rules:
#     - if: $CI_COMMIT_TAG
#   script:
#      - echo "Rodando o comando Apenas se for na hora de adicionar uma tag"
#      - echo "Adicionando a tag" ${CI_COMMIT_REF_NAME}

# Roda-Toda-vez-que-tiver-push-job:
#   rules:
#     - if: '$CI_PIPELINE_SOURCE == "push"'
#   script:
#     - echo "Code testing scripts here, for example."


##Ativar na config do git o block de merge request se tiver falhas
# roda-a-todo-merge-request-job:
#   rules:
#     - if: '$CI_PIPELINE_SOURCE == "merge_request_event"'
#   script:
#     - echo "No tests run, but this pipeline always succeeds and enables merge."
#     - exit 0 #1 com erro, 0 sem erro


